var STUDENTS_URL = 'http://xavier.h4x0r.space:9999/search';

function requestJSON(url, callback) {
    var request = new XMLHttpRequest();

    request.onreadystatechange = function() {
	if (request.readyState == 4 && request.status == 200) {
	    callback(JSON.parse(request.responseText));
	}
    }

    request.open('GET', url, true);
    request.send();
}

function fetchSearchResults() {
    var query = document.getElementById('query');
    var field = document.getElementById('field');
    var url   = STUDENTS_URL + '?query=' + query.value + '&field=' + field.value;

    requestJSON(url, function(data) {
	var results = document.getElementById('results');
	var html    = '';

	try {
	    html += '<table class="table table-striped">';
	    html += '<thead><th>NetID</th><th>Classification</th><th>First Name</th><th>Last Name</th></thead><tbody>';
	    for (var index in data['results']) {
	    	var student = data['results'][index];

	    	html += '<tr>';
	    	for (var i = 0; i < 4; i++) {
		    html += '<td>' + student[i] + '</td>';
		}
	    	html += '</tr>';
	    }
	    html += '</tbody></table>';
	} catch (err) {
	    html += '<div class="alert alert-warning">';
	    html += '<h4><i class="fa fa-warning"></i> No search results.</h4>';
	    html += '<p>There are no results for ' + query.value + ' in ' + field.value + '</p>';
	    html += '</div>';
	}

	results.innerHTML = html;
    });
}

window.onload = function() {
    var query = document.getElementById('query');

    query.onkeyup = fetchSearchResults;
    query.onkeyup();
}
